#include <bits/stdc++.h>
using namespace std;

int gcd(int x, int y) {
    while (y != 0) {
        int t = x % y;
        x = y;
        y = t;
    }
    return x;
}

bool is_prime(int x) {
    if (x == 1) return false;
    int g = 2;
    while (g * g <= x) {
        if (x % g == 0) {
            return false;
        }
        g++;
    }
    return true;
}

int main() {
    int n;
    cin >> n;
    int l, r;
    cin >> l >> r;
    
    vector<int> ans;
    for (int i = l; i <= r; i++) {
        int g = gcd(i, n);
        if (i != n && (g == 1 || is_prime(g))) {
            ans.push_back(i);
        }
    }

    cout << ans.size() << endl;
    for (int x : ans) {
        cout << x << " ";
    }
    return 0;
}
