import java.io.PrintStream;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

public final class d_gk {
    private final Scanner in;
    private final PrintStream out;

    private d_gk(final Scanner in, final PrintStream out) {
        this.in = in;
        this.out = out;
    }

    public static void main(final String[] args) {
        final Scanner in = new Scanner(System.in, StandardCharsets.UTF_8);
        while (in.hasNext()) {
            new d_gk(in, System.out).solve();
        }
    }

    private void solve() {
        final int n = in.nextInt();
        final List<Integer> answer = new ArrayList<>();
        find(n, 0, 0, answer);
    }

    private void find(final int n, final int prev, final int last, final List<Integer> answer) {
        if (n == 0) {
            out.println(answer.stream().map(String::valueOf).collect(Collectors.joining("+")));
            return;
        }

        final int forbidden = prev == 0 ? 0 : 2 * last - prev;
        for (int i = last + 1; i <= n; i++) {
            if (i != forbidden) {
                answer.add(i);
                find(n - i, last, i, answer);
                answer.remove(answer.size() - 1);
            }
        }
    }
}
