import java.io.PrintStream;
import java.nio.charset.StandardCharsets;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.stream.IntStream;

public final class e_gk_wa_int {
    private final Scanner in;
    private final PrintStream out;

    private e_gk_wa_int(final Scanner in, final PrintStream out) {
        this.in = in;
        this.out = out;
    }

    public static void main(final String[] args) {
        final Scanner in = new Scanner(System.in, StandardCharsets.UTF_8);
        while (in.hasNext()) {
            new e_gk_wa_int(in, System.out).solve();
        }
    }

    private void solve() {
        final int n = in.nextInt();
        final int k = in.nextInt();
        final int[] a = IntStream.generate(in::nextInt).limit(n).toArray();
        final Map<Integer, Integer> counts = new HashMap<>();
        counts.put(0, 1);
        int sum = 0;
        for (final int i : a) {
            sum = (sum + i) % k;
            counts.merge(sum, 1, Integer::sum);
        }
        out.println(counts.values().stream().mapToInt(c -> (c * (c - 1)) / 2).sum());
    }
}
