#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);
    int n = inf.readInt();
    int k = inf.readInt();

    string ja = ans.readWord("YES|NO");
    string pa = ouf.readWord("YES|NO");
    
    if (ja != pa) {
        quitf(_wa, "expected: %s, found: %s", ja.c_str(), pa.c_str());
    }
    if (ja == "NO") {
        quitf(_ok, "NO");
    }

    int s = 0;
    vector<int> a = ouf.readInts(k, 1, n, "a");
    set<int> was;
    for (int i = 0; i < k; i++) {
        if (was.count(a[i]) > 0) {
            quitf(_wa, "duplicate number: %d", a[i]);
        }
        was.insert(a[i]);
        s += a[i];
    }

    if (s != n) {
        quitf(_wa, "the sum of given numbers is %d instead of %d", s, n);
    }

    for (int i = 0; i < k; i++) {
        int t = round(sqrt(n - a[i]));
        if (t * t != n - a[i]) {
            quitf(_wa, "the sum of all numbers except %d is %d, not a perfect square", a[i], n - a[i]);
        }
    }

    quitf(_ok, "YES");
}
