import java.util.*;
import java.math.*;
import java.io.*;

public class squary_as implements Runnable {
    public void solve() throws IOException {
        Scanner in = new Scanner(System.in);
        PrintWriter out = new PrintWriter(System.out);

        int n = in.nextInt();
        int k = in.nextInt();

        ArrayList<Integer> v = new ArrayList<Integer>();
        for (int i = 1; i * i < n; i++) {
            v.add(n - i * i);
        }

        int[] a = new int[v.size()];
        for (int i = 0; i < v.size(); i++) {
            a[i] = v.get(i);
        }
        int m = a.length;

        boolean[][] c = new boolean[k + 1][n + 1];
        int[] max = new int[k + 1];
        int[][] last = new int[k + 1][n + 1];
        c[0][0] = true;
        for (int i = 0; i < m; i++) {
            for (int j = k - 1; j >= 0; j--) {
                for (int t = 0; t <= n - a[i] && t <= max[j]; t++) {
                    if (c[j][t] && !c[j + 1][t + a[i]]) {
                        c[j + 1][t + a[i]] = true;
                        last[j + 1][t + a[i]] = i;
                        max[j + 1] = Math.max(max[j + 1], t + a[i]);
                    }
                }
            }
        }

        if (c[k][n]) {
            out.println("YES");
            int j = n;
            for (int i = k; i > 0; i--) {
                out.print(a[last[i][j]] + " ");
                j = j - a[last[i][j]];
            }
            out.println();
        } else {
            out.println("NO");
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            throw new AssertionError();
        }
    }

    public static void main(String[] args) {
        new Thread(new squary_as()).start();
    }
}